## vtk7 7.1.1+dfsg2

=== Accelerators/Dax/CMakeLists.txt ===
##=============================================================================
##
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##
##  Copyright 2012 Sandia Corporation.
##  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
##  the U.S. Government retains certain rights in this software.
##
##=============================================================================

#ensure we link against our dependencies
include(module.cmake)

find_package(Dax REQUIRED)

DaxConfigureSerial(REQUIRED)
DaxConfigureCuda()
DaxConfigureTBB()
DaxConfigureOpenMP()

# Collect a list of available backends.
set(DAX_BACKENDS)
if(${Dax_ENABLE_CUDA})
  list(APPEND DAX_BACKENDS CUDA)
endif()
if(${Dax_ENABLE_TBB})
  list(APPEND DAX_BACKENDS TBB)
endif()
if(${Dax_ENABLE_OPENMP})
  list(APPEND DAX_BACKENDS OPENMP)
endif()
list(APPEND DAX_BACKENDS SERIAL)

# Pick the first backed found in list as the default backend
list(GET DAX_BACKENDS 0 DEFAULT_BACKEND)

# Display available options for user selection.
set(VTK_DAX_BACKEND ${DEFAULT_BACKEND} CACHE STRING
  "Choose from available backend acclerators")
set_property(CACHE VTK_DAX_BACKEND PROPERTY STRINGS ${DAX_BACKENDS})

# Turn the picked option on and turn off the others.
foreach(backend ${DAX_BACKENDS})
  if(${backend} STREQUAL ${VTK_DAX_BACKEND})
    set(VTK_DAX_PICKED_${backend} TRUE)
  else()
    set(VTK_DAX_PICKED_${backend} FALSE)
  endif()
endforeach()

# Setting the configuration file to include the appropriate driver.
#we prefer cuda over everything else, than tbb and openmp
set (DAX_DISABLE_BOOST_SP_THREADS 0)
if(${VTK_DAX_PICKED_CUDA})
  set (DAX_DISABLE_BOOST_SP_THREADS 1)
  set (DAX_DEVICE_ADAPTER "DAX_DEVICE_ADAPTER_CUDA")
elseif(${VTK_DAX_PICKED_TBB})
  set (DAX_DEVICE_ADAPTER "DAX_DEVICE_ADAPTER_TBB")
elseif(${VTK_DAX_PICKED_OPENMP})
  set (DAX_DEVICE_ADAPTER "DAX_DEVICE_ADAPTER_OPENMP")
else()
  set (DAX_DEVICE_ADAPTER "DAX_DEVICE_ADAPTER_SERIAL")
endif()

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/vtkDaxConfig.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkDaxConfig.h" @ONLY)

#needed for our export macros
include_directories(${${vtk-module}_DEPENDS_INCLUDE_DIRS}
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${CMAKE_CURRENT_SOURCE_DIR}
                    ${Dax_INCLUDE_DIRS}
                   )

set(headers
  vtkDaxDetailCommon.h
  vtkDaxContourImpl.h
  vtkDaxThresholdImpl.h
  vtkDaxConfig.h
  )

#implementation of the algorithms for cpu accelerators
set(cpu_accelerator_srcs
  vtkDaxContourImpl.cxx
  vtkDaxThresholdImpl.cxx
  )

set(vtk_srcs
  vtkDaxContour.cxx
  vtkDaxThreshold.cxx
  ${CMAKE_CURRENT_BINARY_DIR}/vtkAcceleratorsDaxObjectFactory.cxx
  )

set_source_files_properties(
  ${headers}
  ${cpu_accelerator_srcs}
  ${CMAKE_CURRENT_BINARY_DIR}/vtkAcceleratorsDaxObjectFactory.cxx
  PROPERTIES
    WRAP_EXCLUDE 1
    WRAP_EXCLUDE_PYTHON 1
  )

# Now for the object factory.
set(opengl_overrides
  Contour
  Threshold
  )
# Now we need to generate the object factory for this module. Create a list of
# overrides, and then generate the class that overrides those classes.
set(vtk_module_overrides)
foreach(_override ${opengl_overrides})
  list(APPEND vtk_module_overrides vtk${_override})
  set(vtk_module_vtk${_override}_override vtkDax${_override})
endforeach()

# Now we iterate and create that class file...
foreach(_class ${vtk_module_overrides})
  set(_override ${vtk_module_${_class}_override})
  set(_vtk_override_includes "${_vtk_override_includes}
#include \"${_override}.h\"")
  set(_vtk_override_creates "${_vtk_override_creates}
VTK_CREATE_CREATE_FUNCTION(${_override})")
  set(_vtk_override_do "${_vtk_override_do}
  this->RegisterOverride(\"${_class}\",
                         \"${_override}\",
                         \"rride for ${vtk-module} module\", 1,
                         vtkObjectFactoryCreate${_override});")
endforeach()

# Now lets create the object factory classes
string(TOUPPER ${vtk-module} VTK-MODULE)
configure_file(${VTK_CMAKE_DIR}/vtkObjectFactory.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/${vtk-module}ObjectFactory.h)
configure_file(${VTK_CMAKE_DIR}/vtkObjectFactory.cxx.in
  ${CMAKE_CURRENT_BINARY_DIR}/${vtk-module}ObjectFactory.cxx)
list(APPEND Module_SRCS
  ${CMAKE_CURRENT_BINARY_DIR}/${vtk-module}ObjectFactory.cxx)
set_source_files_properties(
  ${vtk-module}ObjectFactory.cxx
  WRAP_EXCLUDE
  )

#we are building with CUDA support
if(${VTK_DAX_PICKED_CUDA})

  #implementation of the algorithms for gpu accelerators
  set(cuda_accelerator_srcs
    vtkDaxContourImpl.cu
    vtkDaxThresholdImpl.cu
    )


  #follow pistons example on how to build a subsection of the cuda with nvcc
  if(BUILD_SHARED_LIBS)
    set(GPGPU_BUILD_TYPE SHARED)
  endif()
  set(CUDA_ATTACH_VS_BUILD_RULE_TO_CUDA_FILE OFF) #otherwise C_SOURCES is empty in VS
  vtk_module_impl()

  cuda_compile(cuda_compiled_srcs
               ${cuda_accelerator_srcs}
               ${headers}
               ${GPGPU_BUILD_TYPE})

  set_source_files_properties(
    ${cuda_compiled_srcs}
    ${cuda_accelerator_srcs}
    WRAP_EXCLUDE
    )

  vtk_module_library(vtkAcceleratorsDax ${vtk_srcs} ${cuda_compiled_srcs}
                                        ${headers})
  vtk_module_link_libraries(vtkAcceleratorsDax LINK_PRIVATE ${CUDA_LIBRARIES})

elseif(${VTK_DAX_PICKED_TBB})
  vtk_module_library(vtkAcceleratorsDax ${vtk_srcs}
                                        ${cpu_accelerator_srcs} ${headers})
  vtk_module_link_libraries(vtkAcceleratorsDax LINK_PRIVATE ${TBB_LIBRARIES})
else()

  vtk_module_library(vtkAcceleratorsDax ${vtk_srcs}
                                        ${cpu_accelerator_srcs} ${headers})

endif()

#install the required headers to make your own dax vtk filter
if(NOT VTK_INSTALL_NO_DEVELOPMENT)
  install(DIRECTORY
    ${CMAKE_CURRENT_SOURCE_DIR}/vtkToDax
    DESTINATION ${VTK_INSTALL_INCLUDE_DIR}
    COMPONENT Development)
  install(DIRECTORY
    ${CMAKE_CURRENT_SOURCE_DIR}/daxToVtk
    DESTINATION ${VTK_INSTALL_INCLUDE_DIR}
    COMPONENT Development)
endif()

=== Common/Color/CMakeLists.txt ===
set(Module_SRCS
  vtkColorSeries.cxx
  vtkNamedColors.cxx
)

#set_source_files_properties(
#  ABSTRACT
#  WRAP_EXCLUDE
#)

vtk_module_library(vtkCommonColor ${Module_SRCS})

=== Common/Core/CMakeLists.txt ===
# Core configuration options.
if("${CMAKE_SIZEOF_VOID_P}" GREATER 4)
 set(VTK_USE_64BIT_IDS_DEFAULT ON)
else()
 set(VTK_USE_64BIT_IDS_DEFAULT OFF)
endif()

option(VTK_USE_64BIT_IDS "Build VTK with 64 bit ids"
  ${VTK_USE_64BIT_IDS_DEFAULT})

option(VTK_DEBUG_LEAKS "Build leak checking support into VTK." OFF)

# This option determines the behavior of the New methods of vtkObject derived
# classes. If this option is off then only classes specifically using the
# vtkObjectFactoryNewMacro and vtkAbstractObjectFactoryNewMacro will allow for
# overrides. If the method is on then vtkStandardNewMacro will use the
# vtkObjectFactoryNewMacro's implementation body.
option(VTK_ALL_NEW_OBJECT_FACTORY
  "Build all vtkObject derived classes with object factory new methods." OFF)

mark_as_advanced(VTK_DEBUG_LEAKS VTK_USE_64BIT_IDS VTK_ALL_NEW_OBJECT_FACTORY)

set(vtkCommonCore_EXPORT_OPTIONS
  VTK_DEBUG_LEAKS
  VTK_USE_64BIT_IDS
  VTK_ALL_NEW_OBJECT_FACTORY
  )

# Choose which multi-threaded parallelism library to use
set(VTK_SMP_IMPLEMENTATION_TYPE_DOC_STRING "Which multi-threaded parallelism implementation to use. Options are Sequential, OpenMP or TBB")

set(VTK_SMP_IMPLEMENTATION_TYPE "Sequential" CACHE STRING ${VTK_SMP_IMPLEMENTATION_TYPE_DOC_STRING})

set_property(CACHE VTK_SMP_IMPLEMENTATION_TYPE PROPERTY STRINGS Sequential OpenMP TBB)

if( NOT ("${VTK_SMP_IMPLEMENTATION_TYPE}" STREQUAL "OpenMP" OR
         "${VTK_SMP_IMPLEMENTATION_TYPE}" STREQUAL "TBB") )
  set(VTK_SMP_IMPLEMENTATION_TYPE "Sequential" CACHE STRING ${VTK_SMP_IMPLEMENTATION_TYPE_DOC_STRING} FORCE)
endif()

set(VTK_SMP_SOURCES "")
set(VTK_SMP_HEADERS "")
set(VTK_SMP_USE_DEFAULT_ATOMICS ON)

if ("${VTK_SMP_IMPLEMENTATION_TYPE}" STREQUAL "TBB")
  find_package(TBB REQUIRED)
  set(VTK_SMP_IMPLEMENTATION_LIBRARIES ${TBB_LIBRARIES})
  include_directories(${TBB_INCLUDE_DIRS})
  # This needs to be here because all modules that include vtkAtomic.h
  # need to include tbb/atomic.h
  list(APPEND vtkCommonCore_SYSTEM_INCLUDE_DIRS ${TBB_INCLUDE_DIRS})

  set(VTK_SMP_USE_DEFAULT_ATOMICS OFF)
  set(VTK_SMP_IMPLEMENTATION_DIR "${CMAKE_CURRENT_SOURCE_DIR}/SMP/TBB")
  set(VTK_SMP_SOURCES ${VTK_SMP_IMPLEMENTATION_DIR}/vtkSMPTools.cxx)
  set(VTK_SMP_HEADERS_TO_CONFIG
    vtkAtomic.h vtkSMPToolsInternal.h vtkSMPThreadLocal.h)

elseif ("${VTK_SMP_IMPLEMENTATION_TYPE}" STREQUAL "OpenMP")
  find_package(OpenMP REQUIRED)
  add_definitions(${OpenMP_CXX_FLAGS})
  set(VTK_SMP_IMPLEMENTATION_LIBRARIES "${OpenMP_CXX_LIBRARIES}")

  set(VTK_SMP_IMPLEMENTATION_DIR "${CMAKE_CURRENT_SOURCE_DIR}/SMP/OpenMP")
  set(VTK_SMP_SOURCES ${VTK_SMP_IMPLEMENTATION_DIR}/vtkSMPTools.cxx
    ${VTK_SMP_IMPLEMENTATION_DIR}/vtkSMPThreadLocalImpl.cxx)
  set(VTK_SMP_HEADERS_TO_CONFIG
    vtkSMPToolsInternal.h vtkSMPThreadLocal.h vtkSMPThreadLocalImpl.h)

  if (OpenMP_CXX_SPEC_DATE AND NOT ${OpenMP_CXX_SPEC_DATE} LESS 201107)
    set(VTK_SMP_USE_DEFAULT_ATOMICS OFF)
    list(APPEND VTK_SMP_SOURCES ${VTK_SMP_IMPLEMENTATION_DIR}/vtkAtomic.cxx)
    list(APPEND VTK_SMP_HEADERS_TO_CONFIG vtkAtomic.h)
  else()
    message(WARNING "Required OpenMP version (3.1) for atomics not detected. Using default atomics implementation.")
  endif()

elseif ("${VTK_SMP_IMPLEMENTATION_TYPE}" STREQUAL "Sequential")
  set(VTK_SMP_IMPLEMENTATION_LIBRARIES)
  set(VTK_SMP_IMPLEMENTATION_DIR "${CMAKE_CURRENT_SOURCE_DIR}/SMP/Sequential")
  set(VTK_SMP_SOURCES ${VTK_SMP_IMPLEMENTATION_DIR}/vtkSMPTools.cxx)
  set(VTK_SMP_HEADERS_TO_CONFIG vtkSMPToolsInternal.h vtkSMPThreadLocal.h)
endif()

if (${VTK_SMP_USE_DEFAULT_ATOMICS})
  set(VTK_ATOMICS_DEFAULT_IMPL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/SMP/Sequential")
  list(APPEND VTK_SMP_SOURCES ${VTK_ATOMICS_DEFAULT_IMPL_DIR}/vtkAtomic.cxx)
  configure_file(${VTK_ATOMICS_DEFAULT_IMPL_DIR}/vtkAtomic.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/vtkAtomic.h COPYONLY)
  list(APPEND VTK_SMP_HEADERS ${CMAKE_CURRENT_BINARY_DIR}/vtkAtomic.h)
endif()

foreach (HDR_FILE ${VTK_SMP_HEADERS_TO_CONFIG})
  configure_file(${VTK_SMP_IMPLEMENTATION_DIR}/${HDR_FILE}.in
    ${CMAKE_CURRENT_BINARY_DIR}/${HDR_FILE} COPYONLY)
  list(APPEND VTK_SMP_HEADERS ${CMAKE_CURRENT_BINARY_DIR}/${HDR_FILE})
endforeach()

list(APPEND VTK_SMP_HEADERS vtkSMPTools.h vtkSMPThreadLocalObject.h)

#-------------------------------------------------------------------------------
# Generate the vtkTypeList_Create macros:
include(vtkCreateTypeListMacros)
CreateTypeListMacros(
  VTK_TYPELISTMACRO_HEADER_CONTENTS
  99
  vtkTypeList_Create
  "vtkTypeList::TypeList"
  "vtkTypeList::NullType"
)
configure_file(vtkTypeListMacros.h.in vtkTypeListMacros.h)

#-------------------------------------------------------------------------------
# And the ArrayDispatch array list header:
option(VTK_DISPATCH_AOS_ARRAYS
  "Include array-of-structs vtkDataArray subclasses in dispatcher."
  ON
)
option(VTK_DISPATCH_SOA_ARRAYS
  "Include struct-of-arrays vtkDataArray subclasses in dispatcher."
  OFF
)
option(VTK_DISPATCH_TYPED_ARRAYS
  "Include vtkTypedDataArray subclasses (e.g. old mapped arrays) in dispatcher."
  OFF
)
include(vtkCreateArrayDispatchArrayList)
vtkArrayDispatch_default_array_setup()
vtkArrayDispatch_generate_array_header(VTK_ARRAYDISPATCH_ARRAY_LIST)
configure_file(vtkArrayDispatchArrayList.h.in vtkArrayDispatchArrayList.h)

option(VTK_WARN_ON_DISPATCH_FAILURE
  "If enabled, vtkArrayDispatch will print a warning when a dispatch fails."
  OFF
)

mark_as_advanced(
  VTK_DISPATCH_AOS_ARRAYS
  VTK_DISPATCH_SOA_ARRAYS
  VTK_DISPATCH_TYPED_ARRAYS
  VTK_WARN_ON_DISPATCH_FAILURE
)

#-----------------------------------------------------------------------------

include_directories(${VTK_SOURCE_DIR}/ThirdParty/utf8/source)

SET(Module_SRCS
  vtkAbstractArray.cxx
  vtkAngularPeriodicDataArray.txx
  vtkAnimationCue.cxx
  vtkAOSDataArrayTemplate.txx
  vtkArrayCoordinates.cxx
  vtkArray.cxx
  vtkArrayExtents.cxx
  vtkArrayExtentsList.cxx
  vtkArrayIterator.cxx
  vtkArrayIteratorTemplate.txx
  vtkArrayIteratorTemplateInstantiate.cxx
  vtkArrayRange.cxx
  vtkArraySort.cxx
  vtkArrayWeights.cxx
  vtkBitArray.cxx
  vtkBitArrayIterator.cxx
  vtkBoxMuellerRandomSequence.cxx
  vtkBreakPoint.cxx
  vtkByteSwap.cxx
  vtkCallbackCommand.cxx
  vtkCharArray.cxx
  vtkCollection.cxx
  vtkCollectionIterator.cxx
  vtkCommand.cxx
  vtkCommonInformationKeyManager.cxx
  vtkConditionVariable.cxx
  vtkCriticalSection.cxx
  vtkDataArrayCollection.cxx
  vtkDataArrayCollectionIterator.cxx
  vtkDataArray.cxx
  vtkDataArraySelection.cxx
  vtkDebugLeaks.cxx
  vtkDebugLeaksManager.cxx
  vtkDoubleArray.cxx
  vtkDynamicLoader.cxx
  vtkEventForwarderCommand.cxx
  vtkFileOutputWindow.cxx
  vtkFloatArray.cxx
  vtkFloatingPointExceptions.cxx
  vtkGarbageCollector.cxx
  vtkGarbageCollectorManager.cxx
  vtkGaussianRandomSequence.cxx
  vtkIdListCollection.cxx
  vtkIdList.cxx
  vtkIdTypeArray.cxx
  vtkIndent.cxx
  vtkInformation.cxx
  vtkInformationDataObjectKey.cxx
  vtkInformationDoubleKey.cxx
  vtkInformationDoubleVectorKey.cxx
  vtkInformationIdTypeKey.cxx
  vtkInformationInformationKey.cxx
  vtkInformationInformationVectorKey.cxx
  vtkInformationIntegerKey.cxx
  vtkInformationIntegerPointerKey.cxx
  vtkInformationIntegerVectorKey.cxx
  vtkInformationIterator.cxx
  vtkInformationKey.cxx
  vtkInformationKeyLookup.cxx
  vtkInformationKeyVectorKey.cxx
  vtkInformationObjectBaseKey.cxx
  vtkInformationObjectBaseVectorKey.cxx
  vtkInformationRequestKey.cxx
  vtkInformationStringKey.cxx
  vtkInformationStringVectorKey.cxx
  vtkInformationUnsignedLongKey.cxx
  vtkInformationVariantKey.cxx
  vtkInformationVariantVectorKey.cxx
  vtkInformationVector.cxx
  vtkInstantiator.cxx
  vtkIntArray.cxx
  vtkLargeInteger.cxx
  vtkLongArray.cxx
  vtkLongLongArray.cxx
  vtkLookupTable.cxx
  vtkMappedDataArray.txx
  vtkMath.cxx
  vtkMersenneTwister.cxx
  vtkMinimalStandardRandomSequence.cxx
  vtkMultiThreader.cxx
  vtkMutexLock.cxx
  vtkObjectBase.cxx
  vtkObject.cxx
  vtkObjectFactoryCollection.cxx
  vtkObjectFactory.cxx
  vtkOldStyleCallbackCommand.cxx
  vtkOStreamWrapper.cxx
  vtkOStrStreamWrapper.cxx
  vtkOutputWindow.cxx
  vtkOverrideInformationCollection.cxx
  vtkOverrideInformation.cxx
  vtkPeriodicDataArray.txx
  vtkPoints2D.cxx
  vtkPoints.cxx
  vtkPriorityQueue.cxx
  vtkRandomSequence.cxx
  vtkReferenceCount.cxx
  vtkScalarsToColors.cxx
  vtkShortArray.cxx
  vtkSignedCharArray.cxx
  vtkSimpleCriticalSection.cxx
  vtkSmartPointerBase.cxx
  vtkSOADataArrayTemplate.txx
  vtkSOADataArrayTemplateInstantiate.cxx
  vtkSortDataArray.cxx
  vtkStdString.cxx
  vtkStringArray.cxx
  vtkStringOutputWindow.cxx
  vtkTimePointUtility.cxx
  vtkTimeStamp.cxx
  vtkTypedDataArray.txx
  vtkUnicodeStringArray.cxx
  vtkUnicodeString.cxx
  vtkUnsignedCharArray.cxx
  vtkUnsignedIntArray.cxx
  vtkUnsignedLongArray.cxx
  vtkUnsignedLongLongArray.cxx
  vtkUnsignedShortArray.cxx
  vtkVariantArray.cxx
  vtkVariant.cxx
  vtkVersion.cxx
  vtkVoidArray.cxx
  vtkWeakPointerBase.cxx
  vtkWindow.cxx
  vtkXMLFileOutputWindow.cxx
  vtkDenseArray.txx
  vtkSparseArray.txx
  vtkTypedArray.txx
  vtkTypeTemplate.h
  vtkType.h
  vtkSystemIncludes.h
  vtkWrappingHints.h
  ${VTK_SMP_SOURCES}
  ${VTK_SMP_HEADERS}
  ${CMAKE_CURRENT_BINARY_DIR}/vtkConfigure.h
  ${CMAKE_CURRENT_BINARY_DIR}/vtkMathConfigure.h
  ${CMAKE_CURRENT_BINARY_DIR}/vtkVersionMacros.h
  )

set(${vtk-module}_HDRS
  vtkABI.h
  vtkAngularPeriodicDataArray.h
  vtkArrayDispatch.h
  vtkArrayDispatch.txx
  vtkArrayInterpolate.h
  vtkArrayInterpolate.txx
  vtkArrayIteratorIncludes.h
  vtkArrayIteratorTemplateImplicit.txx
  vtkArrayPrint.h
  vtkArrayPrint.txx
  vtkAssume.h
  vtkAtomicTypeConcepts.h
  vtkAtomicTypes.h
  vtkAutoInit.h
  vtkBuffer.h
  vtkDataArrayAccessor.h
  vtkDataArrayIteratorMacro.h
  vtkDataArrayTemplate.h
  vtkGenericDataArray.h
  vtkGenericDataArrayLookupHelper.h
  vtkGenericDataArray.txx
  vtkIOStream.h
  vtkIOStreamFwd.h
  vtkInformationInternals.h
  vtkMappedDataArray.h
  vtkMathUtilities.h
  vtkMersenneTwister.h
  vtkNew.h
  vtkPeriodicDataArray.h
  vtkSetGet.h
  vtkSmartPointer.h
  vtkSOADataArrayTemplate.h
  vtkSOADataArrayTemplate.txx
  vtkTemplateAliasMacro.h
  vtkTestDataArray.h
  vtkTypeList.h
  vtkTypeList.txx
  vtkTypeTraits.h
  vtkTypedDataArray.h
  vtkTypedDataArrayIterator.h
  vtkVariantCast.h
  vtkVariantCreate.h
  vtkVariantExtract.h
  vtkVariantInlineOperators.h
  vtkWeakPointer.h
  vtkWin32Header.h
  vtkWindows.h
  ${CMAKE_CURRENT_BINARY_DIR}/vtkArrayDispatchArrayList.h
  ${CMAKE_CURRENT_BINARY_DIR}/vtkToolkits.h
  ${CMAKE_CURRENT_BINARY_DIR}/vtkTypeListMacros.h
  )

if(vtkCommonDataModel_ENABLED)
  include_directories(${VTK_BINARY_DIR}/Common/DataModel)
  set_property(SOURCE vtkInformationDataObjectKey.cxx
    PROPERTY COMPILE_DEFINITIONS vtkCommonDataModel_ENABLED)
endif()

if(WIN32)
  # TODO: VTK_USE_X was once tested here but is now in another module
  list(APPEND Module_SRCS
    vtkWin32OutputWindow.cxx
    vtkWin32OutputWindowProcessEncoded.c
    vtkWin32ProcessOutputWindow.cxx
    )
  set_property(SOURCE vtkWin32OutputWindowProcessEncoded.c PROPERTY WRAP_EXCLUDE 1)
endif()

if(ANDROID)
  list(APPEND Module_SRCS
    vtkAndroidOutputWindow.cxx
    )
endif()

# Generate data for folding Unicode strings
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/vtkUnicodeString.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/vtkUnicodeString.cmake @ONLY)

# Setup clean configuration of vtkConfigure.h and vtkToolkits.h.
macro(VTK_PREPARE_CMAKEDEFINE not invar outvar)
  if(${not} ${invar})
    set(${outvar} 1)
  else()
    set(${outvar})
  endif()
endmacro()

vtk_prepare_cmakedefine("" CMAKE_WORDS_BIGENDIAN VTK_WORDS_BIGENDIAN)

# Provide version macros through vtkConfigure.h for compatibility.
if(VTK_LEGACY_REMOVE)
  set(VTK_CONFIG_LEGACY_VERSION "")
else()
  set(VTK_CONFIG_LEGACY_VERSION "#include \"vtkVersionMacros.h\" // removed by VTK_LEGACY_REMOVE")
endif()

# Check for atomic functions
include(CheckSymbolExists)
if (WIN32)
  check_symbol_exists(InterlockedAdd "windows.h" VTK_HAS_INTERLOCKEDADD)
endif()

=== Examples/Android/CMakeLists.txt ===
add_subdirectory(NativeVTK)
add_subdirectory(JavaVTK)
if (OPENGL_ES_VERSION STREQUAL "3.0")
  add_subdirectory(VolumeRender)
endif()

=== Filters/AMR/CMakeLists.txt ===
set(Module_SRCS
  vtkAMRCutPlane.cxx
  vtkAMRGaussianPulseSource.cxx
  vtkAMRResampleFilter.cxx
  vtkAMRSliceFilter.cxx
  vtkAMRToMultiBlockFilter.cxx
  vtkImageToAMR.cxx
  vtkParallelAMRUtilities.cxx
  )

set_source_files_properties(
  vtkAMRBaseReader
  vtkAMRBaseParticlesReader
  ABSTRACT
  )

set_source_files_properties(
  vtkAMRUtilities
  WRAP_EXCLUDE
  )

vtk_module_library(vtkFiltersAMR ${Module_SRCS})

=== Filters/Extraction/CMakeLists.txt ===
set(Module_SRCS
  vtkConvertSelection.cxx
  vtkExtractArraysOverTime.cxx
  vtkExtractBlock.cxx
  vtkExtractCells.cxx
  vtkExtractDataOverTime.cxx
  vtkExtractDataSets.cxx
  vtkExtractEdges.cxx
  vtkExtractGeometry.cxx
  vtkExtractGrid.cxx
  vtkExtractLevel.cxx
  vtkExtractPolyDataGeometry.cxx
  vtkExtractRectilinearGrid.cxx
  vtkExtractSelectedBlock.cxx
  vtkExtractSelectedIds.cxx
  vtkExtractSelectedLocations.cxx
  vtkExtractSelectedPolyDataIds.cxx
  vtkExtractSelectedRows.cxx
  vtkExtractSelectedThresholds.cxx
  vtkExtractSelection.cxx
  vtkExtractTemporalFieldData.cxx
  vtkExtractTensorComponents.cxx
  vtkExtractTimeSteps.cxx
  vtkExtractUnstructuredGrid.cxx
  vtkExtractVectorComponents.cxx

  vtkProbeSelectedLocations.cxx
  vtkHierarchicalDataExtractDataSets.cxx
  vtkHierarchicalDataExtractLevel.cxx
  )

set_source_files_properties(
  vtkExtractSelectionBase
  ABSTRACT
  )

vtk_module_library(vtkFiltersExtraction ${Module_SRCS})

=== Filters/Hybrid/CMakeLists.txt ===
set(Module_SRCS
  vtkBSplineTransform.cxx
  vtkDepthSortPolyData.cxx
  vtkDSPFilterDefinition.cxx
  vtkDSPFilterGroup.cxx
  vtkEarthSource.cxx
  vtkFacetReader.cxx
  vtkForceTime.cxx
  vtkGreedyTerrainDecimation.cxx
  vtkGridTransform.cxx
  vtkImageToPolyDataFilter.cxx
  vtkImplicitModeller.cxx
  vtkPCAAnalysisFilter.cxx
  vtkPolyDataSilhouette.cxx
  #vtkPolyDataToImageStencil.cxx
  vtkProcrustesAlignmentFilter.cxx
  vtkProjectedTerrainPath.cxx
  vtkRenderLargeImage.cxx
  vtkTemporalDataSetCache.cxx
  vtkTemporalFractal.cxx
  vtkTemporalInterpolator.cxx
  vtkTemporalShiftScale.cxx
  vtkTemporalSnapToTimeStep.cxx
  vtkTransformToGrid.cxx
  vtkWeightedTransformFilter.cxx
  )

vtk_module_library(vtkFiltersHybrid ${Module_SRCS})

=== Filters/ParallelDIY2/CMakeLists.txt ===
if (NOT WIN32)
  include(vtkMPI)
  include(vtkObjectFactory)

  set(Module_SRCS
    vtkPResampleToImage.cxx
    vtkPResampleWithDataSet.cxx
    )

  vtk_add_override(vtkResampleToImage vtkPResampleToImage)
  vtk_add_override(vtkResampleWithDataSet vtkPResampleWithDataSet)

  vtk_object_factory_configure("${vtk_module_overrides}")
  list(APPEND Module_SRCS
    ${CMAKE_CURRENT_BINARY_DIR}/${vtk-module}ObjectFactory.cxx)
  set_source_files_properties(
    ${vtk-module}ObjectFactory.cxx
    PROPERTIES
      WRAP_EXCLUDE 1
      WRAP_EXCLUDE_PYTHON 1
    )

  add_definitions(-DDIY_NO_THREADS)

  vtk_module_library(vtkFiltersParallelDIY2 ${Module_SRCS})
  vtk_mpi_link(vtkFiltersParallelDIY2)
endif()

=== Filters/ParallelStatistics/CMakeLists.txt ===
set(Module_SRCS
  vtkPAutoCorrelativeStatistics.cxx
  vtkPContingencyStatistics.cxx
  vtkPCorrelativeStatistics.cxx
  vtkPDescriptiveStatistics.cxx
  vtkPKMeansStatistics.cxx
  vtkPMultiCorrelativeStatistics.cxx
  vtkPOrderStatistics.cxx
  vtkPPCAStatistics.cxx
  vtkPBivariateLinearTableThreshold.cxx
  )

vtk_module_library(vtkFiltersParallelStatistics ${Module_SRCS})

=== Filters/SMP/CMakeLists.txt ===
set(Module_SRCS
  vtkSMPContourGrid.cxx
  vtkSMPContourGridManyPieces.cxx
  vtkSMPMergePoints.cxx
  vtkSMPMergePolyDataHelper.cxx
  vtkThreadedSynchronizedTemplates3D.cxx
  vtkThreadedSynchronizedTemplatesCutter3D.cxx
  vtkSMPTransform.cxx
  vtkSMPWarpVector.cxx
  )

set_source_files_properties(
  vtkSMPMergePolyDataHelper
  WRAP_EXCLUDE
  )

vtk_module_library(vtkFiltersSMP ${Module_SRCS})

=== Filters/Sources/CMakeLists.txt ===
set(Module_SRCS
  vtkArcSource.cxx
  vtkArrowSource.cxx
  vtkButtonSource.cxx
  vtkConeSource.cxx
  vtkCubeSource.cxx
  vtkCylinderSource.cxx
  vtkDiskSource.cxx
  vtkEllipseArcSource.cxx
  vtkEllipticalButtonSource.cxx
  vtkFrustumSource.cxx
  vtkGlyphSource2D.cxx
  vtkHyperOctreeFractalSource.cxx
  vtkHyperTreeGridSource.cxx
  vtkLineSource.cxx
  vtkOutlineCornerFilter.cxx
  vtkOutlineCornerSource.cxx
  vtkOutlineSource.cxx
  vtkParametricFunctionSource.cxx
  vtkPlaneSource.cxx
  vtkPlatonicSolidSource.cxx
  vtkPointSource.cxx
  vtkPolyLineSource.cxx
  vtkProgrammableDataObjectSource.cxx
  vtkProgrammableSource.cxx
  vtkRectangularButtonSource.cxx
  vtkRegularPolygonSource.cxx
  #vtkRRandomTableSource.cxx # Should be in R kit
  #vtkSectorSource.cxx # Needs vtkRotationalExtrusionFilter
  vtkSelectionSource.cxx
  vtkSphereSource.cxx
  vtkSuperquadricSource.cxx
  vtkTessellatedBoxSource.cxx
  vtkTextSource.cxx
  vtkTexturedSphereSource.cxx
  vtkGraphToPolyData.cxx
  vtkDiagonalMatrixSource.cxx
  )

set_source_files_properties(
  vtkButtonSource
  ABSTRACT
  )

vtk_module_library(vtkFiltersSources ${Module_SRCS})

=== Filters/Statistics/CMakeLists.txt ===
set(Module_SRCS
  vtkAutoCorrelativeStatistics.cxx
  vtkBivariateLinearTableThreshold.cxx
  vtkComputeQuartiles.cxx
  vtkContingencyStatistics.cxx
  vtkCorrelativeStatistics.cxx
  vtkDescriptiveStatistics.cxx
  vtkHighestDensityRegionsStatistics.cxx
  vtkExtractFunctionalBagPlot.cxx
  vtkKMeansDistanceFunctorCalculator.cxx
  vtkKMeansDistanceFunctor.cxx
  vtkKMeansStatistics.cxx
  vtkMultiCorrelativeStatistics.cxx
  vtkOrderStatistics.cxx
  vtkPCAStatistics.cxx
  vtkStatisticsAlgorithm.cxx
  vtkStrahlerMetric.cxx
  vtkStreamingStatistics.cxx
  )

set_source_files_properties(
  vtkStatisticsAlgorithm.cxx
  ABSTRACT
)

vtk_module_library(vtkFiltersStatistics ${Module_SRCS})

=== debian/changelog ===
vtk7 (7.1.1+dfsg2-2ubuntu1) focal; urgency=medium

  * d/p/mysql8_my_bool.patch: Reintroduce my_bool to fix build with MySQL 8.
    (LP: #1863026)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 19 Feb 2020 21:46:28 +0100

=== debian/control ===
Source: vtk7
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gert Wollny <gewo@debian.org>,
           Nico Schlömer <nico.schloemer@gmail.com>
Section: graphics
Priority: optional
Build-Depends: chrpath,
               cmake (>= 3.2.0),
               debhelper (>= 9),
               default-jdk,
               default-libmysqlclient-dev,
               dh-python,
               libftgl-dev,
               hdf5-tools,
               javahelper,
               libalglib-dev,
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev,
               libboost-all-dev,
               libdigest-md5-perl,
               libexpat-dev,
               libfreetype6-dev,
               libfontconfig1-dev,
               libgdal-dev,
               libgl1-mesa-dev | libgl-dev,
               libgl2ps-dev (>= 1.4.0),
               libglew-dev,
               libglu1-mesa-dev | libglu-dev,
               libhdf5-mpi-dev,
               libjpeg-dev,
               libjsoncpp-dev,
               libmrmpi-dev,
               libnetcdf-dev,
               libnetcdf-cxx-legacy-dev,
               libogg-dev,
               libosmesa6-dev,
               libpng-dev,
               libpq-dev,
               libproj-dev,
               libqt5opengl5-dev,
               libqt5webkit5-dev,
               libqt5x11extras5-dev,
               libsqlite3-dev,
               libswscale-dev,
               libtheora-dev,
               libtiff-dev,
               libutfcpp-dev,
               libx11-dev,
               libxml2-dev,
               libxpm-dev,
               libxt-dev,
               mpi-default-dev,
               pkg-config,
               python3-dev,
               python3-autobahn,
               python3-matplotlib,
               python3-mpi4py,
               python3-six,
               python3-twisted,
               qtbase5-dev,
               qttools5-private-dev,
               r-base,
               r-base-core,
               r-base-dev,
               tcl-dev,
               tk-dev,
               x11proto-core-dev,
               xauth,
               xvfb,
               zlib1g-dev
Build-Depends-Indep: doxygen-latex,
                     texlive-binaries,
                     graphviz,
                     ghostscript,
                     libjs-mathjax,
                     gnuplot-nox
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/science-team/vtk7
Vcs-Git: https://salsa.debian.org/science-team/vtk7.git
Homepage: http://www.vtk.org/

Package: libvtk7-dev
Architecture: any
Section: libdevel
Depends: default-libmysqlclient-dev,
         libavcodec-dev,
         libavformat-dev,
         libavutil-dev,
         libc6-dev,
         libeigen3-dev,
         libexpat-dev,
         libfreetype6-dev,
         libgdal-dev,
         libgl1-mesa-dev | libgl-dev,
         libgl2ps-dev,
         libglew-dev,
         libglu1-mesa-dev | libglu-dev,
         libhdf5-mpi-dev,
         libjpeg-dev,
         libjsoncpp-dev,
         libnetcdf-dev,
         libnetcdf-cxx-legacy-dev,
         libogg-dev,
         libpng-dev,
         libpq-dev,
         libproj-dev,
         libpython3-dev,
         libswscale-dev,
         libtheora-dev,
         libtiff-dev,
         libvtk7.1p (= ${binary:Version}),
         libvtk7-java (= ${binary:Version}),
         libx11-dev,
         libxft-dev,
         libxml2-dev,
         libxss-dev,
         libxt-dev,
         mpi-default-dev,
         python3-vtk7 (= ${binary:Version}),
         python3-zope.interface,
         tcl-dev,
         tcl-vtk7 (= ${binary:Version}),
         tk-dev,
         vtk7 (= ${binary:Version}),
         x11proto-core-dev,
         zlib1g-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: vtk7-doc,
          vtk7-examples
Conflicts: libvtk5-dev
Replaces: libvtk5-dev
Description: VTK header files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the VTK header files required to compile
 C++ programs that use VTK to do 3D visualisation.

Package: libvtk7-qt-dev
Architecture: any
Section: libdevel
Depends: libvtk7-dev (= ${binary:Version}),
         libvtk7.1p-qt (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         qtbase5-dev,
         qttools5-private-dev,
         libqt5opengl5-dev,
         libqt5webkit5-dev
Description: VTK header files, containing Qt files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the VTK header files required to compile
 C++ programs that use VTK to do 3D visualisation. Qt files

Package: libvtk7.1p
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: mpi-default-bin,
          vtk7-doc,
          vtk7-examples
Conflicts: libvtk7 (>> 6.0.0-7)
Replaces: libvtk5.8,
          libvtk7
Description: VTK libraries
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries needed to run C++ programs
 that use VTK.

Package: libvtk7.1p-qt
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: VTK libraries, Qt files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries needed to run C++ programs
 that use VTK. Qt files

Package: libvtk7-jni
Architecture: any
Section: java
Depends: ${java:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: libvtk6-jni
Replaces: libvtk6-jni
Description: Visualization Toolkit - A high level 3D visualization library - java
 The Visualization Toolkit (VTK) is an object oriented, high level
 library that allows one to easily write C++ programs, Tcl, Python and
 Java scripts that do 3D visualization.
 .
 This package provides the VTK Java language support.

Package: libvtk7-java
Architecture: any
Section: java
Depends: libvtk7-jni (= ${binary:Version}),
         ${java:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: java-virtual-machine,
          libvtk7-dev (= ${binary:Version}),
          vtk7-doc,
          vtk7-examples
Breaks: libvtk6-java
Replaces: libvtk6-java
Description: Visualization Toolkit - A high level 3D visualization library - java
 The Visualization Toolkit (VTK) is an object oriented, high level
 library that allows one to easily write C++ programs, Tcl, Python and
 Java scripts that do 3D visualization.
 .
 This package provides the VTK Java language support.

Package: python3-vtk7
Architecture: any
Section: python
Depends: libvtk7.1p (= ${binary:Version}),
         libvtk7.1p-qt (= ${binary:Version}) [!armhf !armel],
         python3-autobahn,
         python3-mpi4py,
         python3-six,
         python3-twisted,
         python3-zope.interface,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: mayavi2,
          vtk7-doc,
          vtk7-examples
Breaks: python3-vtk6
Replaces: python3-vtk6
Description: Python bindings for VTK
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the python3 bindings for VTK.

Package: tcl-vtk7
Architecture: any
Section: interpreters
Depends: libvtk7.1p (= ${binary:Version}),
         libvtk7.1p-qt (= ${binary:Version}) [!armhf !armel],
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: vtk7-doc,
          vtk7-examples
Description: Tcl bindings for VTK
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries and executable that enable 
 one to use VTK from Tcl/Tk scripts.

Package: vtk7
Architecture: any
Section: interpreters
Depends: libvtk7.1p (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: vtk7-doc,
          vtk7-examples
Description: Binaries for VTK7
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides binaries for VTK7

Package: vtk7-doc
Architecture: all
Section: doc
Depends: doc-base,
         libjs-jquery,
         libjs-mathjax,
         ${misc:Depends}
Suggests: libvtk7-dev,
          vtk7-examples
Description: VTK class reference documentation
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides documentation for VTK7

Package: vtk7-examples
Architecture: all
Section: graphics
Depends: ${misc:Depends}
Suggests: libvtk7-dev,
          python3,
          python3-vtk7,
          tcl-vtk7,
          tclsh,
          vtk7-doc
Description: VTK examples
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides examples for VTK7

=== debian/rules ===
#!/usr/bin/make -f
BUILDDIR = $(CURDIR)/debian/build

# deduce documentation option (build-indep target)
ifeq "" "$(filter %-doc,$(shell dh_listpackages))"
  BUILDDOC = OFF
else
  BUILDDOC = ON
endif

ifeq ($(DEB_BUILD_ARCH),i386)
  # Tests are permanently failing, try force rounding to normal double 
  # accuracy
  export DEB_CXXFLAGS_MAINT_APPEND=-ffloat-store
endif 

ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH),hppa hurd-i386))
        JAVA_VERSION=1.5
else
        JAVA_VERSION=1.8
endif

noqt_archs="" 
ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH), $(noqt_archs)))
        extra_flags=-DVTK_Group_Qt=OFF \
                    -DMODULE_vtkParseOGLExt=ON  \
                    -DModule_vtkWrappingTools=ON \
                    -DModule_vtkRenderingSceneGraph=ON \
                    -DModule_vtkIOExportOpenGL2=ON \
                    -DModule_vtkPython=ON \
                    -DVTK_BUILD_ALL_MODULES=OFF
else
        extra_flags += -DVTK_QT_VERSION=5 \
                       -DVTK_Group_Qt=ON \
                       -DVTK_BUILD_ALL_MODULES=ON
endif


# export JAVA_HOME to help FindJava.cmake and FindJNI.cmake
export JAVA_HOME=/usr/lib/jvm/default-java

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR) --with python3 --with javahelper --parallel

extra_flags +=  \
  -DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_C_COMPILER=mpicc \
	-DCMAKE_CXX_COMPILER=mpic++ \
	-DBUILD_DOCUMENTATION=$(BUILDDOC) \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DBUILD_TESTING=OFF \
        -DVTK_JAVA_SOURCE_VERSION=$(JAVA_VERSION) \
        -DVTK_JAVA_TARGET_VERSION=$(JAVA_VERSION) \
	-DVTK_USE_TK=ON \
	-DVTK_WRAP_JAVA=ON \
	-DVTK_WRAP_PYTHON=ON \
        -DVTK_PYTHON_VERSION:STRING=3 \
	-DVTK_WRAP_TCL=ON \
	-DVTK_USE_SYSTEM_AUTOBAHN=ON \
	-DVTK_USE_SYSTEM_CONSTANTLY=ON \
	-DVTK_USE_SYSTEM_EXPAT=ON \
	-DVTK_USE_SYSTEM_FREETYPE=ON \
	-DVTK_USE_SYSTEM_GL2PS=ON \
	-DVTK_USE_SYSTEM_GLEW=ON \
	-DVTK_USE_SYSTEM_HDF5=ON \
        -DHDF5_PREFER_PARALLEL=ON \
	-DVTK_USE_SYSTEM_INCREMENTAL=ON \
	-DVTK_USE_SYSTEM_JPEG=ON \
	-DVTK_USE_SYSTEM_JSONCPP=ON \
	-DVTK_USE_SYSTEM_LIBPROJ4=OFF \
	-DVTK_USE_SYSTEM_LIBXML2=ON \
	-DVTK_USE_SYSTEM_MPI4PY=ON \
	-DVTK_USE_SYSTEM_NETCDF=ON \
	-DVTK_USE_SYSTEM_OGGTHEORA=ON \
	-DVTK_USE_SYSTEM_PNG=ON \
	-DVTK_USE_SYSTEM_SIX=ON \
	-DVTK_USE_SYSTEM_TIFF=ON \
	-DVTK_USE_SYSTEM_TWISTED=ON \
	-DVTK_USE_SYSTEM_ZLIB=ON \
	-DVTK_USE_SYSTEM_ZOPE=ON \
	-DVTK_EXTRA_COMPILER_WARNINGS=ON \
	-DVTK_Group_Imaging=ON \
	-DVTK_Group_MPI=ON \
	-DVTK_Group_Tk=ON \
	-DVTK_Group_Views=ON \
	-DVTK_INSTALL_LIBRARY_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)" \
	-DVTK_INSTALL_PYTHON_MODULE_DIR="/usr/lib/python3/dist-packages" \
	-DVTK_MAKE_INSTANTIATORS=ON \
	-DCMAKE_EXE_LINKER_FLAGS="-Wl,--as-needed" \
	-DCMAKE_MODULE_LINKER_FLAGS="-Wl,--as-needed" \
	-DCMAKE_SHARED_LINKER_FLAGS="-Wl,--as-needed" \
	-DCMAKE_BUILD_TYPE=None \
	-DVTK_USE_GCC_VISIBILITY=ON \
	-DModule_vtkRenderingExternal=ON


override_dh_auto_configure:
ifeq (,$(filter $(DEB_HOST_ARCH),$(noqt_archs)))
	echo '' > $(CURDIR)/Views/Qt/module.cmake
	echo '' > $(CURDIR)/GUISupport/QtWebkit/module.cmake
	echo '' > $(CURDIR)/Rendering/Qt/module.cmake
	echo '' > $(CURDIR)/GUISupport/QtOpenGL/module.cmake
	echo '' > $(CURDIR)/Examples/GUI/Qt/SimpleView/CMakeLists.txt
endif
	dh_auto_configure -- $(extra_flags)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)

override_dh_auto_build-indep:
	# Make doc (see http://www.vtk.org/Wiki/VTK/BuildingDoxygen)
	cd $(BUILDDIR) && make DoxygenDoc
	# remove .md5 files
	find $(BUILDDIR)/Utilities/Doxygen/doc/html/ -name "*.md5" | xargs rm -f

override_dh_auto_build-arch: 
	dh_auto_build 

override_dh_auto_install:
	pwd
	dh_auto_install -X.pyc -X.pyo
	# Modify vtkWrapJava.cmake to properly upload JavaDependencies.cmake.in	from $VTK_DIR
	perl -pi -e "s|{dir}/JavaDependencies.cmake.in\"|{VTK_DIR}/JavaDependencies.cmake.in\"|" debian/tmp/usr/lib/cmake/vtk-7.1/vtkWrapJava.cmake
	# Correct headers for paraview
	perl -pi.bak -e "s|cxx|include|g" ThirdParty/netcdf/vtk_netcdfcpp.h
	mv $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/vtk.jar $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/vtk7.jar
	mv $(CURDIR)/debian/build/bin/vtkpython $(CURDIR)/debian/build/bin/vtk7python
	sed -i -e "s/FATAL_ERROR/STATUS/g" $(CURDIR)/debian/tmp/usr/lib/cmake/vtk-7.1/VTKTargets.cmake
	chrpath -d $(CURDIR)/debian/build/bin/vtk7python
	chrpath -d $(CURDIR)/debian/build/bin/pvtk
	chrpath -d $(CURDIR)/debian/build/bin/pvtkpython
	mv $(CURDIR)/debian/tmp/usr/bin/vtk $(CURDIR)/debian/tmp/usr/bin/vtk7
	find $(CURDIR)/debian/tmp/ -name "*.pyc" | xargs rm -f
	find $(CURDIR)/debian/tmp/ -name "*.pyo" | xargs rm -f
	sed -i -e "9 a\ append libPath /${DEB_HOST_MULTIARCH}" $(CURDIR)/debian/tmp/usr/lib/tcltk/vtk-7.1/pkgIndex.tcl

override_dh_install-arch:
	dh_install -a
	find $(CURDIR)/debian/libvtk7-dev/ -name "*Qt*" -exec rm {} \;
	find $(CURDIR)/debian/libvtk7.1p/ -name "*Qt*" -exec rm {} \;
	find $(CURDIR)/debian/libvtk7-dev/usr/include/ -name "Q*" -exec rm {} \;
	find $(CURDIR)/debian/libvtk7-dev/ -name "libvtkRenderingPythonTkWidgets.so" -exec rm {} \;
	chmod 755 $(CURDIR)/debian/libvtk7-dev/usr/share/vtk-7.1/doxygen/*.pl
	rm -rf $(CURDIR)/debian/libvtk7-doc/usr/share/doc/vtk7-doc/html/_formulas.log

=== debian/tests/control ===
Tests: buildBoolean buildPoint buildVTU buildDistance buildPNG buildVTP
Depends: libvtk7-dev, build-essential, cmake
Restrictions: allow-stderr
